C                                                     <PUGIgnoreBegin>
    
C> @file umock_base.f The base standalone file for testing subroutines.
C>    Defines core concepts and placeholders that the client replaces.
C>    This description will not be copied to the exported files.

C                                                       <PUGIgnoreEnd>
C ======================================================================

C=======================================================================
C            _                     _           _     _             
C           | |                   | |         | |   | |            
C      ____ | | ____  ____ ____   | | _   ___ | | _ | | ____  ____ 
C     |  _ \| |/ _  |/ ___/ _  )  | || \ / _ \| |/ || |/ _  )/ ___)(_)
C     | | | | ( ( | ( (__( (/ /   | | | | |_| | ( (_| ( (/ /| |    
C     | ||_/|_|\_||_|\____\____)  |_| |_|\___/|_|\____|\____|_|    (_)
C     |_|                                                          
C     ------------------------------------------------------------------
C     doxygen file info
C=======================================================================

C ======================================================================
C> @brief The parameters detailed here are copied from
C>    <a href="https://abaqus-docs.mit.edu/2017/English/SIMACAESUBRefMap/simasub-c-umat.htm#simasub-c-umat">
C>     the online documentation
C>    </a>.
C>
C> @details The subroutine \p umat and its requirement are defined and
C>    imposed by Simulia/Abaqus conventions.
C ----------------------------------------------------------------------

C ======================================================================
      SUBROUTINE Umock( stress, d_strain, d_t,
     +                  statev, ns, props,nprops, 
     +                  ddsdde
     +)

      ! I/O
      integer ns, infor, nprops
      real*8 stress(6), d_strain(6), d_t, statev(ns), props(nprops)
      real*8 ddsdde(6,6)

      ! other
      real*8 algmod(6,6)
      real*8 svec(6), dstrain(6)
C=======================================================================
C            _                     _           _     _             
C           | |                   | |         | |   | |            
C      ____ | | ____  ____ ____   | | _   ___ | | _ | | ____  ____ 
C     |  _ \| |/ _  |/ ___/ _  )  | || \ / _ \| |/ || |/ _  )/ ___)(_)
C     | | | | ( ( | ( (__( (/ /   | | | | |_| | ( (_| ( (/ /| |    
C     | ||_/|_|\_||_|\____\____)  |_| |_|\___/|_|\____|\____|_|    (_)
C     |_|                                                          
C     ------------------------------------------------------------------
C     props splitting
C=======================================================================

c ------------ From ABAQUS to natural basis ---------------------------
      call voigt_to_natural(STRESS, svec, D_STRAIN, dstrain)

c ------------ THE CORE ROUTINE - RETURN-MAPPING ALGORITHM ------------

      call Return_Map(svec, dstrain, d_t,
     +                STATEV, NS,
     +                par_HT, np_HT, 
     +                par_EL, np_EL, 
     +                par_ES, np_ES, 
     +                par_RS, np_RS, 
     +                algmod, infor)

c ------------ From natural basis back to abaqus Voigt ----------------
      call natural_to_voigt(STRESS, svec, algmod, ddsdde)

      RETURN

C=======================================================================
C            _                     _           _     _             
C           | |                   | |         | |   | |            
C      ____ | | ____  ____ ____   | | _   ___ | | _ | | ____  ____ 
C     |  _ \| |/ _  |/ ___/ _  )  | || \ / _ \| |/ || |/ _  )/ ___)(_)
C     | | | | ( ( | ( (__( (/ /   | | | | |_| | ( (_| ( (/ /| |    
C     | ||_/|_|\_||_|\____\____)  |_| |_|\___/|_|\____|\____|_|    (_)
C     |_|                                                          
C     ------------------------------------------------------------------
C     format 200
C=======================================================================

      END SUBROUTINE Umock

C=======================================================================
C            _                     _           _     _             
C           | |                   | |         | |   | |            
C      ____ | | ____  ____ ____   | | _   ___ | | _ | | ____  ____ 
C     |  _ \| |/ _  |/ ___/ _  )  | || \ / _ \| |/ || |/ _  )/ ___)(_)
C     | | | | ( ( | ( (__( (/ /   | | | | |_| | ( (_| ( (/ /| |    
C     | ||_/|_|\_||_|\____\____)  |_| |_|\___/|_|\____|\____|_|    (_)
C     |_|                                                          
C     ------------------------------------------------------------------
C     files inclusions
C=======================================================================

C=======================================================================
C            _                     _           _     _             
C           | |                   | |         | |   | |            
C      ____ | | ____  ____ ____   | | _   ___ | | _ | | ____  ____ 
C     |  _ \| |/ _  |/ ___/ _  )  | || \ / _ \| |/ || |/ _  )/ ___)(_)
C     | | | | ( ( | ( (__( (/ /   | | | | |_| | ( (_| ( (/ /| |    
C     | ||_/|_|\_||_|\____\____)  |_| |_|\___/|_|\____|\____|_|    (_)
C     |_|                                                          
C     ------------------------------------------------------------------
C     UMOCK HELPERS
C=======================================================================
